SystemOrganization addCategory: #'Xenon-Core-Types'!
SystemOrganization addCategory: #'Xenon-Core-Exceptions'!
SystemOrganization addCategory: #'Xenon-Core'!

RBProgramNodeVisitor subclass: #XeAnnotator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core'!

!XeAnnotator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 4/5/2012 16:51'!
acceptPragmaNode: aPragmaNode
	aPragmaNode selector == #returnType: ifTrue: [
		aPragmaNode parent returnType: (aPragmaNode arguments first token value)
		].
	aPragmaNode selector == #var:type: ifTrue: [
		aPragmaNode parent declarations at: (aPragmaNode arguments first token value)
			put: (aPragmaNode arguments second token value asXeType)
		]! !

!XeAnnotator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 4/8/2012 22:43'!
acceptVariableNode: aVariableNode
	aVariableNode variableBinding isArgumentBinding
		ifTrue: [ 
			aVariableNode parent isMethod
				ifTrue: [ aVariableNode parent declarations at: aVariableNode name put: #default asXeType ] ]! !

RBProgramNodeVisitor subclass: #XeFunctionPrototypeTranslator
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core'!

!XeFunctionPrototypeTranslator commentStamp: 'BernardoContreras 4/7/2012 18:42' prior: 0!
To write function prototypes on a stream.
!

!XeFunctionPrototypeTranslator class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/6/2012 21:06'!
newFor: aStream 
	" a new instance for the given stream"
	^ self new stream: aStream; yourself! !

!XeFunctionPrototypeTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 4/8/2012 19:43'!
acceptMethodNode: aMethodNode
	aMethodNode returnType emitOn: stream.
	self space.
	self nextPutAll: aMethodNode cFunctionName.
	self nextPut: $(.
	self visitArguments: aMethodNode arguments.
	self nextPut: $); nextPut: $;; cr.! !

!XeFunctionPrototypeTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 4/7/2012 02:30'!
acceptVariableNode: aVariableNode
	(aVariableNode parent declarations at: aVariableNode name) emitOn: stream.
	self space.
	self nextPutAll: aVariableNode name! !

!XeFunctionPrototypeTranslator methodsFor: 'private writing' stamp: 'BernardoContreras 4/6/2012 22:15'!
cr
	stream cr! !

!XeFunctionPrototypeTranslator methodsFor: 'private writing' stamp: 'BernardoContreras 4/6/2012 22:16'!
nextPut: anObject
	stream nextPut: anObject! !

!XeFunctionPrototypeTranslator methodsFor: 'private writing' stamp: 'BernardoContreras 4/6/2012 22:16'!
nextPutAll: aCollection
	stream nextPutAll: aCollection! !

!XeFunctionPrototypeTranslator methodsFor: 'private writing' stamp: 'BernardoContreras 4/6/2012 22:15'!
space
	stream space! !

!XeFunctionPrototypeTranslator methodsFor: 'accessing' stamp: 'BernardoContreras 4/6/2012 21:10'!
stream: aStream 
	stream := aStream! !

!XeFunctionPrototypeTranslator methodsFor: 'visiting' stamp: 'BernardoContreras 4/8/2012 19:43'!
visitArguments: aNodeCollection
	^ aNodeCollection isEmpty
		ifTrue: [ #void asXeType emitOn: stream ]
		ifFalse: [ aNodeCollection do: [ :each | self visitArgument: each ] separatedBy: [ stream nextPutAll: ', ' ] ]! !

RBProgramNodeVisitor subclass: #XeMethodTranslator
	instanceVariableNames: 'stream indentationLevel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core'!

!XeMethodTranslator commentStamp: 'BernardoContreras 4/7/2012 18:42' prior: 0!
To write functions on a stream
!

!XeMethodTranslator class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/7/2012 02:16'!
newFor: aStream 
	" a new instance for the given stream"
	^ self new stream: aStream; yourself! !

!XeMethodTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 4/7/2012 02:16'!
acceptLiteralNode: aLiteralNode
	self nextPutAll: (self cLiteralValueFor: aLiteralNode token)! !

!XeMethodTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 4/9/2012 04:04'!
acceptMessageNode: aMessageNode
	(aMessageNode isCascaded not or: [ aMessageNode isFirstCascaded ])
		ifTrue: [ self visitNode: aMessageNode receiver ].
	aMessageNode isBinary
		ifTrue: [ 
			self space.
			stream nextPutAll: aMessageNode selector.
			self space.
			aMessageNode arguments do: [ :each | self visitNode: each ] ].
	aMessageNode isKeyword
		ifTrue: [ 
			stream nextPutAll: aMessageNode cFunctionName.
			self nextPut: $(.
			aMessageNode arguments do: [ :each | self visitNode: each ].
			self nextPut: $) ]! !

!XeMethodTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 4/8/2012 19:43'!
acceptMethodNode: aMethodNode
	aMethodNode returnType emitOn: stream.
	self space.
	self nextPutAll: aMethodNode cFunctionName.
	self nextPut: $(.
	self visitArguments: aMethodNode arguments.
	self nextPut: $).
	self visitNode: aMethodNode body! !

!XeMethodTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 4/7/2012 02:16'!
acceptReturnNode: aReturnNode
	self
		nextPutAll: 'return';
		space.
	self visitNode: aReturnNode value! !

!XeMethodTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 4/8/2012 20:10'!
acceptSequenceNode: aSequenceNode
	self
		nextPut: ${;
		cr.
	self incrementIndentation.
	"self visitArguments: aSequenceNode temporaries."
	aSequenceNode statements
		do: [ :each |
			self nextPutIndentation. 
			self visitNode: each.
			self
				nextPut: $;;
				cr ].
	self decrementIndentation.
	self
		nextPut: $};
		cr! !

!XeMethodTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 4/9/2012 02:32'!
acceptVariableNode: aVariableNode
	aVariableNode variableBinding isArgumentBinding
		ifTrue: [ 
			aVariableNode parent isMethod
				ifTrue: [ 
					(aVariableNode parent declarations at: aVariableNode name) emitOn: stream.
					self space ] ].
	aVariableNode variableBinding isSelfBinding not
		ifTrue: [ self nextPutAll: aVariableNode name ]! !

!XeMethodTranslator methodsFor: 'private' stamp: 'BernardoContreras 4/7/2012 02:16'!
cLiteralValueFor: aRBLiteralToken 
	^ aRBLiteralToken value asString! !

!XeMethodTranslator methodsFor: 'private writing' stamp: 'BernardoContreras 4/7/2012 02:16'!
cr
	stream cr! !

!XeMethodTranslator methodsFor: 'private indentation' stamp: 'BernardoContreras 4/7/2012 02:16'!
decrementIndentation
	indentationLevel := indentationLevel - 1! !

!XeMethodTranslator methodsFor: 'private indentation' stamp: 'BernardoContreras 4/7/2012 02:16'!
incrementIndentation
	indentationLevel := indentationLevel + 1! !

!XeMethodTranslator methodsFor: 'initialize-release' stamp: 'BernardoContreras 4/7/2012 02:16'!
initialize
	super initialize.
	indentationLevel := 0! !

!XeMethodTranslator methodsFor: 'private writing' stamp: 'BernardoContreras 4/7/2012 02:16'!
nextPut: anObject
	stream nextPut: anObject! !

!XeMethodTranslator methodsFor: 'private writing' stamp: 'BernardoContreras 4/7/2012 02:16'!
nextPutAll: aCollection
	stream nextPutAll: aCollection! !

!XeMethodTranslator methodsFor: 'private indentation' stamp: 'BernardoContreras 4/7/2012 02:16'!
nextPutIndentation
	stream tab: indentationLevel ! !

!XeMethodTranslator methodsFor: 'private writing' stamp: 'BernardoContreras 4/7/2012 02:16'!
space
	stream space! !

!XeMethodTranslator methodsFor: 'accessing' stamp: 'BernardoContreras 4/7/2012 02:16'!
stream: aStream 
	stream := aStream! !

!XeMethodTranslator methodsFor: 'visiting' stamp: 'BernardoContreras 4/8/2012 19:43'!
visitArguments: aNodeCollection
	^ aNodeCollection isEmpty
		ifTrue: [ #void asXeType emitOn: stream ]
		ifFalse: [ aNodeCollection do: [ :each | self visitArgument: each ] separatedBy: [ stream nextPutAll: ', ' ] ]! !

!RBMessageNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/9/2012 03:59'!
cFunctionName
	"Create a C function name from the given selector by omitting colons"
	^ self selector copyWithout: $:! !

!RBMethodNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/5/2012 15:47'!
cFunctionName
	"Create a C function name from the given selector by omitting colons"
	^ self selector copyWithout: $:
! !

!RBMethodNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/3/2012 00:13'!
declarations
	^ self hasDeclarations
		ifTrue: [ self propertyAt: #declarations ]
		ifFalse: [ self propertyAt: #declarations put: Dictionary new ]! !

!RBMethodNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/3/2012 00:07'!
hasDeclarations
	^ self hasProperty: #declarations! !

!RBMethodNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 3/17/2012 16:33'!
hasReturnType
	^ self hasProperty: #returnType! !

!RBMethodNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/3/2012 00:13'!
returnType
	^ self hasReturnType
		ifTrue: [ (self propertyAt: #returnType) asXeType ]
		ifFalse: [ #default asXeType ]! !

!RBMethodNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 3/25/2012 02:51'!
returnType: typename
	self hasReturnType
		ifTrue: [ 
			XeTooManyReturnTypesError
				signalForSelector: self selector
				returnTypes:
					{(self returnType).
					typename} ]
		ifFalse: [ self propertyAt: #returnType put: typename ]! !

!ByteSymbol methodsFor: '*xenon-core' stamp: 'BernardoContreras 3/19/2012 23:18'!
asXeType
	^ XeTypes default at: self
	! !

Error subclass: #XeTooManyReturnTypesError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Exceptions'!

!XeTooManyReturnTypesError commentStamp: 'BernardoContreras 2/27/2012 19:36' prior: 0!
When a selector in a class has defined too many return types.
A selector in a class should have only one return type.

!

!XeTooManyReturnTypesError class methodsFor: 'signaling' stamp: 'BernardoContreras 3/25/2012 02:51'!
signalForSelector: aSelectorName returnTypes: anArray
	| message |
	message := 'Too many return types for method ' , aSelectorName , '. actual types: ' , anArray asString.
	^ self signal: message! !

Error subclass: #XeTypeNotFoundError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Exceptions'!

!XeTypeNotFoundError commentStamp: 'BernardoContreras 3/19/2012 23:49' prior: 0!
When a type is not found.
!

!XeTypeNotFoundError class methodsFor: 'signaling' stamp: 'BernardoContreras 3/19/2012 23:43'!
signalFor: aSymbol 

	^ self signal: 'Couldn''t find type: ' , aSymbol.! !

Object subclass: #XeCodeGenerator
	instanceVariableNames: 'methods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core'!

!XeCodeGenerator commentStamp: 'BernardoContreras 3/19/2012 22:14' prior: 0!
* Constants are translated only if they are binded in a method.
!

!XeCodeGenerator methodsFor: 'public' stamp: 'BernardoContreras 4/8/2012 21:30'!
addClass: aClass
	aClass methodsDo: [ :method | methods add: ((self parserClass parseMethod: method getSource) annotateInClass: aClass) ]! !

!XeCodeGenerator methodsFor: 'private' stamp: 'BernardoContreras 4/6/2012 18:48'!
annotate
	| annotator |
	annotator := self annotatorClass new.
	methods do: [ :each | annotator visitNode: each ]! !

!XeCodeGenerator methodsFor: 'private' stamp: 'BernardoContreras 3/16/2012 00:31'!
annotatorClass
	^ XeAnnotator! !

!XeCodeGenerator methodsFor: 'public' stamp: 'BernardoContreras 4/9/2012 00:01'!
codeString
	| stream |
	stream := ReadWriteStream on: (String new: 1000).
	self sortMethods.
	self annotate.
	self translateOn: stream.
	^ stream contents! !

!XeCodeGenerator methodsFor: 'initialize-release' stamp: 'BernardoContreras 4/6/2012 19:28'!
initialize
	super initialize.
	methods := OrderedCollection new.! !

!XeCodeGenerator methodsFor: 'private' stamp: 'BernardoContreras 3/15/2012 23:09'!
parserClass
	^ RBParser! !

!XeCodeGenerator methodsFor: 'private' stamp: 'BernardoContreras 4/9/2012 00:06'!
sortMethods
	methods sort: [:a :b| a selector caseSensitiveLessOrEqual: b selector]! !

!XeCodeGenerator methodsFor: 'private' stamp: 'BernardoContreras 4/7/2012 02:17'!
translateOn: aStream
	| translator |
	translator := self translatorClass newFor: aStream.
	translator translate: methods! !

!XeCodeGenerator methodsFor: 'private' stamp: 'BernardoContreras 3/16/2012 00:38'!
translatorClass
	^ XeTranslator! !

Object subclass: #XeTranslator
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core'!

!XeTranslator commentStamp: 'BernardoContreras 4/5/2012 15:50' prior: 0!
To translate to C Code on a stream
!

!XeTranslator class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/5/2012 15:49'!
newFor: aStream 
	" a new instance for the given stream"
	^ self new stream: aStream; yourself! !

!XeTranslator methodsFor: 'private' stamp: 'BernardoContreras 4/7/2012 02:31'!
functionPrototypeTranslatorClass
	^ XeFunctionPrototypeTranslator 
	! !

!XeTranslator methodsFor: 'private' stamp: 'BernardoContreras 4/7/2012 02:31'!
methodTranslatorClass
	^ XeMethodTranslator
	 
	! !

!XeTranslator methodsFor: 'accessing' stamp: 'BernardoContreras 3/16/2012 00:51'!
stream: aStream 
	stream := aStream! !

!XeTranslator methodsFor: 'accessing' stamp: 'BernardoContreras 4/7/2012 02:36'!
translate: methods
	self translateFunctionPrototypesFor: methods.
	self translateMethodsFor: methods! !

!XeTranslator methodsFor: 'private' stamp: 'BernardoContreras 4/7/2012 02:34'!
translateFunctionPrototypesFor: methods
	| translator |
	stream
		nextPutAll: '/*** Function Prototypes ***/';
		cr.
	translator := self functionPrototypeTranslatorClass newFor: stream.
	methods do: [ :each | translator visitNode: each ]! !

!XeTranslator methodsFor: 'private' stamp: 'BernardoContreras 4/7/2012 02:35'!
translateMethodsFor: methods
	| translator |
	translator := self methodTranslatorClass newFor: stream.
	methods do: [ :each | translator visitNode: each ]! !

Object subclass: #XeType
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Types'!

!XeType commentStamp: 'BernardoContreras 2/27/2012 19:07' prior: 0!
To describe types!

!XeType class methodsFor: 'instance creation' stamp: 'BernardoContreras 3/25/2012 03:55'!
name: aString 
	^ self new name: aString.! !

!XeType methodsFor: 'emit code' stamp: 'BernardoContreras 3/25/2012 03:57'!
emitOn: aStream
	"emit the string representation of this type on a stream"

	aStream nextPutAll: name! !

!XeType methodsFor: 'accessing' stamp: 'BernardoContreras 3/25/2012 03:56'!
name: aString 
	name := aString! !

Object subclass: #XeTypes
	instanceVariableNames: 'types'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Types'!

XeTypes class
	instanceVariableNames: 'default'!

!XeTypes commentStamp: 'BernardoContreras 3/20/2012 00:19' prior: 0!
Hold all defined types!

XeTypes class
	instanceVariableNames: 'default'!

!XeTypes class methodsFor: 'singleton' stamp: 'BernardoContreras 3/19/2012 23:57'!
default
	^ default ifNil: [ default := self new ]! !

!XeTypes class methodsFor: 'class initialization' stamp: 'BernardoContreras 3/20/2012 00:04'!
initialize
	default := nil! !

!XeTypes class methodsFor: 'cleanup' stamp: 'BernardoContreras 3/19/2012 23:58'!
reset
	"XeTypes reset"

	default := nil! !

!XeTypes methodsFor: 'accessing' stamp: 'BernardoContreras 3/25/2012 03:43'!
at: aSymbol
	^ types at: aSymbol ifAbsent: [ XeTypeNotFoundError signalFor: aSymbol ]! !

!XeTypes methodsFor: 'initialize-release' stamp: 'BernardoContreras 3/25/2012 03:54'!
initialize
	super initialize.
	types := Dictionary new.
	types at: #int put: (XeType name: 'int').
	types at: #void put: (XeType name: 'void').
	types at: #default put: (XeType name: 'sqInt')! !
XeTypes initialize!
